(function() {
    window.H5lock = function(obj) {
        this.height = obj.height;
        this.width = obj.width;
        this.chooseType = obj.chooseType;
        this.container = obj.container;
        this.inputEnd = obj.inputEnd;
        this.lineColor = obj.lineColor;
        this.circleColor = obj.circleColor;
        this.pointColor = obj.pointColor;
        this.rightColor = obj.rightColor;
        this.noRightColor = obj.noRightColor;
    };

    H5lock.prototype.drawCle = function(x, y) {// 初始化解锁密码面板
        this.ctx.strokeStyle = this.circleColor;
        this.ctx.lineWidth = 2;
        this.ctx.beginPath();
        this.ctx.arc(x, y, this.r, 0, Math.PI * 2, true);
        this.ctx.closePath();
        this.ctx.stroke();

        //          this.ctx.beginPath();
        //          this.ctx.arc(x,y, this.r / 4, 0, Math.PI * 4, true);
        //          this.ctx.closePath();
        //          this.ctx.fillStyle = this.circleColor;
        //          this.ctx.fill();
    }
    H5lock.prototype.drawPoint = function(fillStyle) {// 初始化圆心
        for (var i = 0; i < this.lastPoint.length; i++) {
            this.ctx.fillStyle = fillStyle;
            this.ctx.beginPath();
            this.ctx.arc(this.lastPoint[i].x, this.lastPoint[i].y, this.r / 2, 0, Math.PI * 2, true);
            this.ctx.closePath();
            this.ctx.fill();
        }
    }
    H5lock.prototype.drawStatusPoint = function(type, psw) {// 初始化状态线条
        var obj = {
            'right' : this.rightColor,
            'notright' : this.noRightColor,
            'none' : this.lineColor
        };
        type = obj[type];

        this.drawCircle(type);
        this.drawPoint(type);
        this.drawAllLine(type);
    }

    H5lock.prototype.drawCircle = function(fillStyle) {// 初始化大圆心
        for (var i = 0; i < this.prevPoint.length; i++) {
            this.ctx.strokeStyle = fillStyle;
            this.ctx.beginPath();
            this.ctx.arc(this.prevPoint[i].x, this.prevPoint[i].y, this.r, 0, Math.PI * 2, true);
            this.ctx.closePath();
            this.ctx.stroke();
        }
    }
    H5lock.prototype.drawAllLine = function(fillStyle) {// 解锁轨迹
        this.ctx.beginPath();
        this.ctx.lineWidth = 3;
        this.ctx.strokeStyle = fillStyle;
        for (var i = 0; i < this.lastPoint.length; i++) {
            if (i == 0) {
                this.ctx.moveTo(this.lastPoint[i].x, this.lastPoint[i].y);
            } else {
                this.ctx.lineTo(this.lastPoint[i].x, this.lastPoint[i].y);
            }
        }
        this.ctx.stroke();
        this.ctx.closePath();
    }

    H5lock.prototype.drawLine = function(po, fillStyle) {// 解锁轨迹

        this.ctx.beginPath();
        this.ctx.lineWidth = 3;
        if (this.lastPoint&&this.lastPoint.length > 0) {
            this.ctx.moveTo(this.lastPoint[0].x, this.lastPoint[0].y);

            for (var i = 1; i < this.lastPoint.length; i++) {
                this.ctx.lineTo(this.lastPoint[i].x, this.lastPoint[i].y);
            }
            if (po) {
                this.ctx.lineTo(po.x, po.y);
            }
            this.ctx.stroke();
            this.ctx.closePath();
        }

    }
    H5lock.prototype.createCircle = function() {// 创建解锁点的坐标，根据canvas的大小来平均分配半径

        var n = this.chooseType;
        var count = 0;
        this.r = this.ctx.canvas.width / (2 + 4 * n);
        // 公式计算
        this.lastPoint = [];
        this.arr = [];
        this.restPoint = [];
        var r = this.r;
        for (var i = 0; i < n; i++) {
            for (var j = 0; j < n; j++) {
                count++;
                var obj = {
                    x : j * 4 * r + 3 * r,
                    y : i * 4 * r + 3 * r,
                    index : count
                };
                this.arr.push(obj);
                this.restPoint.push(obj);
            }
        }
        this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
        for (var i = 0; i < this.arr.length; i++) {
            this.drawCle(this.arr[i].x, this.arr[i].y);
        }
        //return arr;
    }
    H5lock.prototype.getPosition = function(e) {// 获取touch点相对于canvas的坐标
        var rect = e.currentTarget.getBoundingClientRect();
        var po = {
            x : e.touches[0].clientX - rect.left,
            y : e.touches[0].clientY - rect.top
        };
        return po;
    }
    H5lock.prototype.update = function(po) {// 核心变换方法在touchmove时候调用
        this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);

        for (var i = 0; i < this.arr.length; i++) {// 每帧先把面板画出来
            this.drawCle(this.arr[i].x, this.arr[i].y);
        }

        this.drawPoint(this.pointColor);
        // 每帧花轨迹
        this.drawLine(po, this.pointColor);
        // 每帧画圆心

        for (var i = 0; i < this.restPoint.length; i++) {
            if (Math.abs(po.x - this.restPoint[i].x) < this.r && Math.abs(po.y - this.restPoint[i].y) < this.r) {
                this.drawPoint(this.pointColor);
                this.lastPoint.push(this.restPoint[i]);
                this.restPoint.splice(i, 1);
                break;
            }
        }

    }

    H5lock.prototype.storePass = function(psw) {// touchend结束之后对密码和状态的处理
        //清除多余的线
        var lastPointTemp = this.lastPoint;
        this.reset();
        this.lastPoint = lastPointTemp;
        this.drawStatusPoint('none');
        this.prevPoint = psw;
        var str = '';
        for (var i = 0; i < psw.length; i++) {
            str += psw[i].index;
        }

        this.inputEnd && this.inputEnd(str);

    }

    H5lock.prototype.setChooseType = function(type) {
        chooseType = type;
        init();
    }
    H5lock.prototype.updatePassword = function() {
        window.localStorage.removeItem('passwordxx');
        window.localStorage.removeItem('chooseType');
        this.pswObj = {};
        document.getElementById('title').innerHTML = '绘制解锁图案';
        this.reset();
    }
    H5lock.prototype.initDom = function() {
        var wrap = document.getElementById(this.container);
        var str = '<canvas id="canvas" width="' + this.width + '" height="' + this.height + '"></canvas>';
        wrap.innerHTML = str;
    }
    H5lock.prototype.init = function() {
        this.initDom();
        this.pswObj = window.localStorage.getItem('passwordxx') ? {
            step : 2,
            spassword : JSON.parse(window.localStorage.getItem('passwordxx'))
        } : {};
        this.lastPoint = [];
        this.prevPoint = [];
        this.touchFlag = false;
        this.canvas = document.getElementById('canvas');
        this.ctx = this.canvas.getContext('2d');
        this.createCircle();
        this.bindEvent();
    }
    H5lock.prototype.reset = function() {
        this.createCircle();
    }
    H5lock.prototype.bindEvent = function() {
        var self = this;
        this.canvas.addEventListener("touchstart", function(e) {
            self.reset();
            e.preventDefault();
            // 某些android 的 touchmove不宜触发 所以增加此行代码
            var po = self.getPosition(e);

            for (var i = 0; i < self.arr.length; i++) {
                if (Math.abs(po.x - self.arr[i].x) < self.r && Math.abs(po.y - self.arr[i].y) < self.r) {

                    self.touchFlag = true;
                    self.drawPoint("#FFFFF");
                    self.lastPoint.push(self.arr[i]);
                    self.restPoint.splice(i, 1);
                    break;
                }
            }
        }, false);
        this.canvas.addEventListener("touchmove", function(e) {
            if (self.touchFlag) {
                self.update(self.getPosition(e));
            }
        }, false);
        this.canvas.addEventListener("touchend", function(e) {
            if (self.touchFlag) {
                self.touchFlag = false;
                self.storePass(self.lastPoint);

            }

        }, false);

    }
})();
